import dayjs from "dayjs";
import * as path from "path";
import { WsServer } from "tsrpc";
import { serviceProto, ServiceType } from "./shared/protocols/serviceProto";
require("dotenv").config();
require("dayjs/locale/zh-tw");
dayjs.locale("zh-tw");

// Create the Server
export const server: WsServer<ServiceType> = new WsServer(serviceProto, {
    port: +process.env.PORT! || 3000,
    // Remove this to use binary mode (remove from the client too)
    json: true
});

// Initialize before server start
async function init(): Promise<void> {
    await server.autoImplementApi(path.resolve(__dirname, "api"));

    // TODO
    // let time: Date = new Date();
    let time: string = dayjs().format("YYYY-MM-DD HH:mm:ss");
    console.log(`${time} Start Server`);
    // Prepare something... (e.g. connect the db)
}

// Entry function
async function main(): Promise<void> {
    await init();
    await server.start();
}
main();